#!/bin/bash
USE_SCORING=0
. ../../../testdata_tools/gen.sh

# ulimit -s unlimited

use_solution nils.cpp

compile gen_random.py
compile gen_star.py
compile gen_path.py

MAXN=300000


sample_manual 1
sample_manual 2


tc small-01 gen_random n=3
tc small-02 gen_random n=4
tc small-03 gen_random n=5
tc small-04 gen_random n=6
tc small-05 gen_random n=10
tc small-06 gen_random n=100
tc small-07 gen_random n=200 b=3
tc smallstar-08 gen_star n=200
tc smallstar-09 gen_star n=200 noise=20
tc random-10 gen_random n=$MAXN
tc random-11 gen_random n=$MAXN
tc random-12 gen_random n=$MAXN
tc random-13 gen_random n=$MAXN b=100
tc random-14 gen_random n=$MAXN b=10
tc random-15 gen_random n=$MAXN b=5
tc random-16 gen_random n=$MAXN b=3
tc star-17 gen_star n=$MAXN
tc star-18 gen_star n=$MAXN noise=1
tc star-19 gen_star n=$MAXN noise=1000
tc doublestar-20 gen_star n=200 mode=double
tc doublestar-21 gen_star n=200 mode=double noise=10
tc doublestar-22 gen_star n=$MAXN mode=double
tc doublestar-23 gen_star n=$MAXN mode=double noise=10
tc line-24 gen_random n=10 b=1
tc line-25 gen_random n=100000 b=1
# tc line-26 gen_random n=$MAXN b=1
tc doublestar-27 gen_star n=6 mode=double
tc doublestar-28 gen_star n=8 mode=double
tc doublestar-29 gen_star n=8 mode=double
tc doublestar-30 gen_star n=8 mode=double
tc doublestar-31 gen_star n=8 mode=double
tc doublestar-32 gen_star n=8 mode=double
tc doublestar-33 gen_star n=16 mode=double
tc doublestar-34 gen_star n=128 mode=double
tc star-35 gen_star n=$MAXN noise=100000
tc path-36 gen_path n=4
tc path-37 gen_path n=4
tc path-38 gen_path n=4
tc path-39 gen_path n=4
tc path-40 gen_path n=4
tc path-41 gen_path n=4
tc path-42 gen_path n=4
tc path-43 gen_path n=4
tc path-44 gen_path n=4
tc path-45 gen_path n=5
tc path-46 gen_path n=6
tc path-47 gen_path n=7
tc path-48 gen_path n=4
tc path-49 gen_path n=4
tc path-50 gen_path n=4
tc path-51 gen_path n=4
tc_manual ../manual_tests/ethylene1.in
tc_manual ../manual_tests/ethylene2.in
tc_manual ../manual_tests/ethylene3.in
tc_manual ../manual_tests/ethylene4.in
tc_manual ../manual_tests/ethylene5.in
tc_manual ../manual_tests/ethylene6.in
