#!/usr/bin/python3

import sys
import random

def cmdlinearg(name, default=None):
    for arg in sys.argv:
        if arg.startswith(name + "="):
            return arg.split("=")[1]
    assert default is not None
    return default

def main():
    Ns = [int(x) for x in cmdlinearg("N").split(",")]
    conjoined = bool(cmdlinearg("conjoined", False))

    O = 0
    print(sum(Ns), sum(Ns))
    for c in Ns:
        for i in range(c - 1):
            print(O + i + 1, O + i + 2)
        print(O + c, O + 1)
        if conjoined:
            O += c - 1
        else:
            O += c
    
if __name__ == "__main__":
    main()
