import math

def max_eds(n, G):
    if G%2 == 1:
        # G = 2G2 + 1
        G2 = (G - 1)//2
        return math.pow(n/2, 1 + 1/(G2)) + n/2
    # G = 2G2 + 2
    G2 = (G - 2)//2
    return math.pow(n, 1 + 1/G2)/math.pow(2, 1 + 1/G2) + n/2


for i in range(3, 30):
    ed = max_eds(3000, i)
    if ed > 6000: continue
    print("Max eds for girth with 3000 vertices", i, "=", max_eds(3000, i))

for i in range(3, 300):
    ed = max_eds(1000, i)
    if ed > 6000: continue
    print("Max eds for girth with 1000 vertices", i, "=", max_eds(1000, i))
