#!/bin/bash
USE_SCORING=0
. ../../../testdata_tools/gen.sh

# ulimit -s unlimited

use_solution nils.cpp

compile gen_random.py

MAXN=5000

sample_manual 1
sample_manual 2


tc random-01 gen_random n=10 k=5
tc random-02 gen_random n=100 k=47
tc random-03 gen_random n=1 k=1
tc random-04 gen_random n=$MAXN k=1
tc random-05 gen_random n=$MAXN k=400
tc random-06 gen_random n=$MAXN k=2210
tc random-07 gen_random n=$MAXN k=2435
tc random-08 gen_random n=$MAXN k=2500
tc random-09 gen_random n=$MAXN k=2511
tc random-10 gen_random n=$MAXN k=2675
tc random-11 gen_random n=$MAXN k=4191
tc random-12 gen_random n=$MAXN k=$MAXN
tc random-13 gen_random n=$MAXN k=$MAXN lo=0.99999
tc random-14 gen_random n=20 k=10 hi=0.50001

tc two-15 gen_random n=20 k=16 lo=0.5 hi=1.0 mode=two
tc two-16 gen_random n=$MAXN k=2000 lo=0.5 hi=1.0 mode=two
tc two-17 gen_random n=$MAXN k=2600 lo=0.5 hi=1.0 mode=two
tc two-18 gen_random n=$MAXN k=3000 lo=0.6 hi=0.7 mode=two
tc two-19 gen_random n=$MAXN k=$MAXN lo=0.9999 hi=0.99999 mode=two
tc two-20 gen_random n=$MAXN k=1 lo=0.5 hi=0.50001 mode=two
tc two-21 gen_random n=$MAXN k=2550 lo=0.5 hi=0.99999 mode=two

tc low-22 gen_random n=$MAXN k=1000 mode=low
tc low-23 gen_random n=$MAXN k=1250 mode=low
tc low-24 gen_random n=$MAXN k=1500 mode=low

tc twogood-25 gen_random n=$MAXN k=1 mode=twogood
tc twogood-26 gen_random n=$MAXN k=2 mode=twogood
tc twogood-27 gen_random n=$MAXN k=3 mode=twogood
