import random

# divides the string into blocks with independent queries.
# Should be good for checking correctness.

n = int(input())
blocks = int(input()) 
mix = int(input()) # shuffle queries

last = random.sample(range(n-1), blocks-1)
last.sort()
last.append(n-1)
Q = []

prev = 0
for i in range(blocks):
    x = prev
    y = last[i]
    for _ in range(2*(y-x+1)):
        if random.randint(0, 1) == 0:
            a = random.randint(x, y)
            b = random.randint(x, y)
            if a > b:
                (a, b) = (b, a)
            Q.append([1,a+1,b+1])
        else:
            d = random.randint(1, y-x+1)
            a = random.randint(x, y-d+1)
            b = random.randint(x, y-d+1)
            Q.append([2,a+1,a+d,b+1,b+d])
    prev = y+1

if mix == 1:
    random.shuffle(Q)

print(n, len(Q))

for row in Q:
    print(*row)

