#!/bin/bash
USE_SCORING=0
. ../../..//testdata_tools/gen.sh

# ulimit -s unlimited

use_solution js.py

compile gen_random.py
compile gen_pat.py

MAXN=100000

sample 1
sample 2

tc small-01 gen_random N=10
tc small-02 gen_random N=10 density=3
tc small-03 gen_random N=10 density=4

tc random-01 gen_random N=$MAXN
tc random-02 gen_random N=$MAXN
tc random-03 gen_random N=$MAXN density=3
tc random-04 gen_random N=$MAXN density=4
tc random-05 gen_random N=$MAXN density=5
tc random-06 gen_random N=$MAXN density=6
tc random-07 gen_random N=$MAXN density=1
tc random-08 gen_random N=$MAXN density=10000000000000
tc pat-01 gen_pat N=$MAXN pat=01
tc pat-02 gen_pat N=$MAXN pat=001
tc pat-03 gen_pat N=$MAXN pat=0001
tc pat-04 gen_pat N=$MAXN pat=101001000
