#!/usr/bin/python3

import sys
import random

def cmdlinearg(name, default=None):
    for arg in sys.argv:
        if arg.startswith(name + "="):
            return arg.split("=")[1]
    assert default is not None
    return default

def main():
    random.seed(int(sys.argv[-1]))
    N = int(cmdlinearg("N"))
    assert N%2 == 0
    at = 318 * 10**9 - 1
    H = []
    while len(H) < N:
        H.append(at)
        H.append(at + 1)
        at -= 2

    print(len(H))
    print(*H)
    
if __name__ == "__main__":
    main()
